
export interface MentionHandleResult { newOffset: number | null, innerHtml: string };

export class Cursor {
    static focusedClassName = "focused";

    static getPosition(element: HTMLElement): number {
        // remove all old focused classes
        for (let node of element.getElementsByClassName(this.focusedClassName)) {
            node.classList.remove(this.focusedClassName);
        }

        // get selection and initialize offset
        let selection = window.getSelection();
        let offset = -1;

        // get currently focused node element and set offset
        if (selection?.focusNode) {
            let node = <HTMLElement>selection.focusNode;
            offset = selection.focusOffset;

            // go to parent if node is not an HTML Element
            while (!node.classList) {
                node = node.parentElement!;
            }

            // mark node as focused
            node.classList?.add(this.focusedClassName);
        }

        return offset;
    }

    static setCurrentCursorPosition(chars: number, element: HTMLElement) {
        let node: any | null = element.getElementsByClassName("focused")[0];

        if (!node)
            node = element;

        let range = document.createRange()
        let sel = window.getSelection()

        if (node && node.firstChild) {
            range.setStart(node.firstChild, chars)
            range.collapse(true)

            sel?.removeAllRanges()
            sel?.addRange(range)
        }
    }
}